org.scalatest

# BeforeAndAfterEach

#### trait BeforeAndAfterEach extends AbstractSuite

Trait that can be mixed into suites that need methods invoked before and after running each test. This trait facilitates a style of testing in which mutable fixture objects held in instance variables are replaced or reinitialized before each test or suite. Here's an example:

    import org.scalatest._
    import scala.collection.mutable.ListBuffer

    class MySuite extends BeforeAndAfterEach {

      // Fixtures as reassignable variables and mutable objects
      var sb: StringBuilder = _
      val lb = new ListBuffer[String]

      override def beforeEach() {
        sb = new StringBuilder("ScalaTest is ")
        lb.clear()
      }

      def testEasy() {
        sb.append("easy!")
        assert(sb.toString === "ScalaTest is easy!")
        assert(lb.isEmpty)
        lb += "sweet"
      }

      def testFun() {
        sb.append("fun!")
        assert(sb.toString === "ScalaTest is fun!")
        assert(lb.isEmpty)
      }
    }

Because this trait invokes `super.runTest` to run each test, you may need to mix this trait in last to get the desired behavior. For example, this won't work, because `BeforeAndAfterEach` is "super" to FunSuite:

    class MySuite extends BeforeAndAfterEach with FunSuite

You'd need to turn it around, so that `FunSuite` is "super" to `BeforeAndAfterEach`, like this:

    class MySuite extends FunSuite with BeforeAndAfterEach

Self Type
  BeforeAndAfterEach with Suite

Linear Supertypes
AbstractSuite, AnyRef, Any
Ordering

1. Alphabetic
2. By inheritance

Inherited

1. Hide All
2. Show all

1. BeforeAndAfterEach
2. AbstractSuite
3. AnyRef
4. Any

Visibility

1. Public
2. All

### Abstract Value Members

1. #### def expectedTestCount (filter: Filter): Int

   The total number of tests that are expected to run when this `Suite`'s `run` method is invoked.

   The total number of tests that are expected to run when this `Suite`'s `run` method is invoked.

   filter

     a `Filter` with which to filter tests to count based on their tags

   Attributes
     abstract
   Definition Classes
     AbstractSuite

2. #### def nestedSuites : List[Suite]

   A `List` of this `Suite` object's nested `Suite`s.

   A `List` of this `Suite` object's nested `Suite`s. If this `Suite` contains no nested `Suite`s, this method returns an empty `List`.

   Attributes
     abstract
   Definition Classes
     AbstractSuite

3. #### def run (testName: Option[String], reporter: Reporter, stopper: Stopper, filter: Filter, configMap: Map[String, Any], distributor: Option[Distributor], tracker: Tracker): Unit

   Runs this suite of tests.

   Runs this suite of tests.

   testName

     an optional name of one test to execute. If `None`, all relevant tests should be executed. I.e., `None` acts like a wildcard that means execute all relevant tests in this `Suite`.

   reporter

     the `Reporter` to which results will be reported

   stopper

     the `Stopper` that will be consulted to determine whether to stop execution early.

   filter

     a `Filter` with which to filter tests based on their tags

   configMap

     a `Map` of key-value pairs that can be used by the executing `Suite` of tests.

   distributor

     an optional `Distributor`, into which to put nested `Suite`s to be executed by another entity, such as concurrently by a pool of threads. If `None`, nested `Suite`s will be executed sequentially.

   tracker

     a `Tracker` tracking `Ordinal`s being fired by the current thread.

   Attributes
     abstract
   Definition Classes
     AbstractSuite

4. #### def runNestedSuites (reporter: Reporter, stopper: Stopper, filter: Filter, configMap: Map[String, Any], distributor: Option[Distributor], tracker: Tracker): Unit

   Runs zero to many of this suite's nested suites.

   Runs zero to many of this suite's nested suites.

   reporter

     the `Reporter` to which results will be reported

   stopper

     the `Stopper` that will be consulted to determine whether to stop execution early.

   filter

     a `Filter` with which to filter tests based on their tags

   configMap

     a `Map` of key-value pairs that can be used by the executing `Suite` of tests.

   distributor

     an optional `Distributor`, into which to put nested `Suite`s to be run by another entity, such as concurrently by a pool of threads. If `None`, nested `Suite`s will be run sequentially.

   tracker

     a `Tracker` tracking `Ordinal`s being fired by the current thread.

   Attributes
     protected abstract
   Definition Classes
     AbstractSuite

5. #### def runTests (testName: Option[String], reporter: Reporter, stopper: Stopper, filter: Filter, configMap: Map[String, Any], distributor: Option[Distributor], tracker: Tracker): Unit

   Runs zero to many of this suite's tests.

   Runs zero to many of this suite's tests.

   testName

     an optional name of one test to run. If `None`, all relevant tests should be run. I.e., `None` acts like a wildcard that means run all relevant tests in this `Suite`.

   reporter

     the `Reporter` to which results will be reported

   stopper

     the `Stopper` that will be consulted to determine whether to stop execution early.

   filter

     a `Filter` with which to filter tests based on their tags

   configMap

     a `Map` of key-value pairs that can be used by the executing `Suite` of tests.

   distributor

     an optional `Distributor`, into which instances of this `Suite` class that are responsible for executing individual tests contained in this Suite, or groups of this `Suite`'s tests, may be placed so as to be run by another entity, such as concurrently by a pool of threads.

   tracker

     a `Tracker` tracking `Ordinal`s being fired by the current thread.

   Attributes
     protected abstract
   Definition Classes
     AbstractSuite

6. #### def tags : Map[String, Set[String]]

   A `Map` whose keys are `String` tag names with which tests in this `Suite` are marked, and whose values are the `Set` of test names marked with each tag.

   A `Map` whose keys are `String` tag names with which tests in this `Suite` are marked, and whose values are the `Set` of test names marked with each tag. If this `Suite` contains no tags, this method returns an empty `Map`.

   Subclasses may implement this method to define and/or discover tags in a custom manner, but overriding method implementations should never return an empty `Set` as a value. If a tag has no tests, its name should not appear as a key in the returned `Map`.

   Attributes
     abstract
   Definition Classes
     AbstractSuite

7. #### def testNames : Set[String]

   An `Set` of test names.

   An `Set` of test names. If this `Suite` contains no tests, this method returns an empty `Set`.

   Although subclass and subtrait implementations of this method may return a `Set` whose iterator produces `String` test names in a well-defined order, the contract of this method does not required a defined order. Subclasses are free to implement this method and return test names in either a defined or undefined order.

   Attributes
     abstract
   Definition Classes
     AbstractSuite

8. #### def withFixture (test: NoArgTest): Unit

   Runs the passed test function with a fixture established by this method.

   Runs the passed test function with a fixture established by this method.

   This method should set up the fixture needed by the tests of the current suite, invoke the test function, and if needed, perform any clean up needed after the test completes. Because the `NoArgTest` function passed to this method takes no parameters, preparing the fixture will require side effects, such as reassigning instance `var`s in this `Suite` or initializing a globally accessible external database. If you want to avoid reassigning instance `var`s you can use FixtureSuite.

   test

     the no-arg test function to run with a fixture

   Attributes
     protected abstract
   Definition Classes
     AbstractSuite

### Concrete Value Members

1. #### def != (arg0: AnyRef): Boolean

   Attributes
     final
   Definition Classes
     AnyRef

2. #### def != (arg0: Any): Boolean

   Attributes
     final
   Definition Classes
     Any

3. #### def ## (): Int

   Attributes
     final
   Definition Classes
     AnyRef → Any

4. #### def == (arg0: AnyRef): Boolean

   Attributes
     final
   Definition Classes
     AnyRef

5. #### def == (arg0: Any): Boolean

   Attributes
     final
   Definition Classes
     Any

6. #### def afterEach (configMap: Map[String, Any]): Unit

   Defines a method (that takes a `configMap`) to be run after each of this suite's tests.

   Defines a method (that takes a `configMap`) to be run after each of this suite's tests.

   This trait's implementation of `runTest` invokes this method after running each test (passing in the `configMap` passed to it), thus this method can be used to tear down a test fixture needed by each test. This trait's implementation of this method invokes the overloaded form of `afterEach` that takes no `configMap`.

   Attributes
     protected

7. #### def afterEach (): Unit

   Defines a method to be run after each of this suite's tests.

   Defines a method to be run after each of this suite's tests.

   This trait's implementation of `runTest` invokes the overloaded form of this method that takes a `configMap` map after running each test. This trait's implementation of that `afterEach(Map[String, Any])` method simply invokes this `afterEach()` method. Thus this method can be used to tear down a test fixture needed by each test, when you don't need anything from the `configMap`. This trait's implementation of this method does nothing.

   Attributes
     protected

8. #### def asInstanceOf [T0] : T0

   Attributes
     final
   Definition Classes
     Any

9. #### def beforeEach (configMap: Map[String, Any]): Unit

   Defines a method (that takes a `configMap`) to be run before each of this suite's tests.

   Defines a method (that takes a `configMap`) to be run before each of this suite's tests.

   This trait's implementation of `runTest` invokes this method before running each test (passing in the `configMap` passed to it), thus this method can be used to set up a test fixture needed by each test. This trait's implementation of this method invokes the overloaded form of `beforeEach` that takes no `configMap`.

   Attributes
     protected

10. #### def beforeEach (): Unit

    Defines a method to be run before each of this suite's tests.

    Defines a method to be run before each of this suite's tests.

    This trait's implementation of `runTest` invokes the overloaded form of this method that takes a `configMap` before running each test. This trait's implementation of that `beforeEach(Map[String, Any])` method simply invokes this `beforeEach()` method. Thus this method can be used to set up a test fixture needed by each test, when you don't need anything from the `configMap`. This trait's implementation of this method does nothing.

    Attributes
      protected

11. #### def clone (): AnyRef

    Attributes
      protected[lang]
    Definition Classes
      AnyRef
    Annotations
      @throws()

12. #### def eq (arg0: AnyRef): Boolean

    Attributes
      final
    Definition Classes
      AnyRef

13. #### def equals (arg0: Any): Boolean

    Definition Classes
      AnyRef → Any

14. #### def finalize (): Unit

    Attributes
      protected[lang]
    Definition Classes
      AnyRef
    Annotations
      @throws()

15. #### def getClass (): java.lang.Class[_]

    Attributes
      final
    Definition Classes
      AnyRef

16. #### def hashCode (): Int

    Definition Classes
      AnyRef → Any

17. #### def isInstanceOf [T0] : Boolean

    Attributes
      final
    Definition Classes
      Any

18. #### def ne (arg0: AnyRef): Boolean

    Attributes
      final
    Definition Classes
      AnyRef

19. #### def notify (): Unit

    Attributes
      final
    Definition Classes
      AnyRef

20. #### def notifyAll (): Unit

    Attributes
      final
    Definition Classes
      AnyRef

21. #### def runTest (testName: String, reporter: Reporter, stopper: Stopper, configMap: Map[String, Any], tracker: Tracker): Unit

    Run a test surrounded by calls to `beforeEach` and `afterEach`.

    Run a test surrounded by calls to `beforeEach` and `afterEach`.

    This trait's implementation of this method ("this method") invokes `beforeEach(configMap)` before running each test and `afterEach(configMap)` after running each test. It runs each test by invoking `super.runTest`, passing along the five parameters passed to it.

    If any invocation of `beforeEach` completes abruptly with an exception, this method will complete abruptly with the same exception. If any call to `super.runTest` completes abruptly with an exception, this method will complete abruptly with the same exception, however, before doing so, it will invoke `afterEach`. If <cod>afterEach also completes abruptly with an exception, this method will nevertheless complete abruptly with the exception previously thrown by `super.runTest`. If `super.runTest` returns normally, but `afterEach` completes abruptly with an exception, this method will complete abruptly with the exception thrown by `afterEach`.

    testName

      the name of one test to execute.

    reporter

      the `Reporter` to which results will be reported

    stopper

      the `Stopper` that will be consulted to determine whether to stop execution early.

    configMap

      a `Map` of key-value pairs that can be used by the executing `Suite` of tests.

    tracker

      a `Tracker` tracking `Ordinal`s being fired by the current thread.

    Attributes
      protected
    Definition Classes
      BeforeAndAfterEach → AbstractSuite

22. #### def synchronized [T0] (arg0: ⇒ T0): T0

    Attributes
      final
    Definition Classes
      AnyRef

23. #### def toString (): String

    Definition Classes
      AnyRef → Any

24. #### def wait (): Unit

    Attributes
      final
    Definition Classes
      AnyRef
    Annotations
      @throws()

25. #### def wait (arg0: Long, arg1: Int): Unit

    Attributes
      final
    Definition Classes
      AnyRef
    Annotations
      @throws()

26. #### def wait (arg0: Long): Unit

    Attributes
      final
    Definition Classes
      AnyRef
    Annotations
      @throws()

### Inherited from AbstractSuite

### Inherited from AnyRef

### Inherited from Any